using UnityEngine;
using System.Collections;
using System;
using UnityEngine.Events;

namespace Mod
{
	public class Mod
	{
		public static void Main()
		{
			CategoryBuilder.Create("Daewo", "", ModAPI.LoadSprite("Doowo.png"));
			ModAPI.Register(
				new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("Human"), 
					NameOverride = "The Daewo", 
					DescriptionOverride = "Daewo is famous Contraption Creator of People Playground Community.", 
					CategoryOverride = ModAPI.FindCategory("Daewo"),
					ThumbnailOverride = ModAPI.LoadSprite("DaewoEntityThumbnail.png"),
					AfterSpawn = (Instance) => 
					{
						var person = Instance.GetComponent<PersonBehaviour>();
						
						var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(person.Limbs[0].PhysicalBehaviour.Properties);
						person.SetBodyTextures(ModAPI.LoadTexture("Daewo.png"), ModAPI.LoadTexture("Daewo.png"), null, 1);

						person.Limbs[0].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("DaewoHead.png", 1);
						person.Limbs[0].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("DaewoHeadFlesh.png"));
						person.Limbs[0].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("DaewoHeadBone.png"));
						
						person.Limbs[1].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("DaewoUpper.png", 1);
						person.Limbs[1].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("DaewoUpperFlesh.png"));
						person.Limbs[1].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("DaewoUpperBone.png"));

						var skin = ModAPI.LoadTexture("Daewo.png");
						var flesh = ModAPI.LoadTexture("DaewoFlesh.png");
						var bone = ModAPI.LoadTexture("DaewoBone.png");

						person.SetBodyTextures(skin, flesh, bone, 1);
						
						//MadeByBarBeQ
						//Commission #1
					}
				}
			);
			ModAPI.Register(
				new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("Android"), 
					NameOverride = "The Daeworoid", 
					DescriptionOverride = "Daeworoid is modular version of Daewo.", 
					CategoryOverride = ModAPI.FindCategory("Daewo"),
					ThumbnailOverride = ModAPI.LoadSprite("DaeworoidEntityThumbnail.png"),
					AfterSpawn = (Instance) => 
					{
						var person = Instance.GetComponent<PersonBehaviour>();
						
						var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(person.Limbs[0].PhysicalBehaviour.Properties);
						person.SetBodyTextures(ModAPI.LoadTexture("Daeworoid.png"), ModAPI.LoadTexture("Daeworoid.png"), null, 1);

						person.Limbs[0].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("DaeworoidHead.png", 1);
						person.Limbs[0].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("DaeworoidHeadFlesh.png"));
						person.Limbs[0].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("DaeworoidHeadBone.png"));
						
						person.Limbs[1].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("DaeworoidUpper.png", 1);
						person.Limbs[1].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("DaeworoidUpperFlesh.png"));
						person.Limbs[1].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("DaeworoidUpperBone.png"));

						var skin = ModAPI.LoadTexture("Daeworoid.png");
						var flesh = ModAPI.LoadTexture("DaeworoidFlesh.png");
						var bone = ModAPI.LoadTexture("DaeworoidBone.png");

						person.SetBodyTextures(skin, flesh, bone, 1);
						
						//MadeByBarBeQ
						//Commission #1
					}
				}
			);
			ModAPI.Register(
				new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("Brick"), 
					NameOverride = "The Daewobrick", 
					DescriptionOverride = "Daewo's head. Actually.", 
					CategoryOverride = ModAPI.FindCategory("Daewo"), 
					ThumbnailOverride = ModAPI.LoadSprite("DaewoBrickThumb.png"),
					AfterSpawn = (Instance) => 
					{
						Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("DaewoBrick.png"); 
						
						//MadeByBarBeQ
						//Commission #1
					}
				}
			);
			ModAPI.Register(
				new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("Rod"), 
					NameOverride = "The Daewostick", 
					DescriptionOverride = "LONG LIVE THE DAEWO!", 
					CategoryOverride = ModAPI.FindCategory("Daewo"), 
					ThumbnailOverride = ModAPI.LoadSprite("DaewoStickThumb.png"),
					AfterSpawn = (Instance) => 
					{
						Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Daewostick.png"); 
						Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Bulletproof");
						Instance.FixColliders();
						
						//MadeByBarBeQ
						//Commission #1
					}
				}
			);
			ModAPI.Register(
				new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("Rod"), 
					NameOverride = "The Daewoball", 
					DescriptionOverride = "This is.", 
					CategoryOverride = ModAPI.FindCategory("Daewo"), 
					ThumbnailOverride = ModAPI.LoadSprite("DaewoBallThumb.png"),
					AfterSpawn = (Instance) => 
					{
						Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Daewoball.png"); 
						Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Bowling ball");
						Instance.FixColliders();
						
						//MadeByBarBeQ
						//Commission #1
					}
				}
			);
			ModAPI.Register(
				new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("Rod"), 
					NameOverride = "The Daewobarrel", 
					DescriptionOverride = "Actually.", 
					CategoryOverride = ModAPI.FindCategory("Daewo"), 
					ThumbnailOverride = ModAPI.LoadSprite("DaewoBarrelThumb.png"),
					AfterSpawn = (Instance) => 
					{
						Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("DaewoBarrel.png"); 
						Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Plastic");
						Instance.FixColliders();
						
						//MadeByBarBeQ
						//Commission #1
					}
				}
			);
			ModAPI.Register(
				new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("Dynamite"), 
					NameOverride = "The Daewonamite", 
					DescriptionOverride = "Actually.", 
					CategoryOverride = ModAPI.FindCategory("Daewo"), 
					ThumbnailOverride = ModAPI.LoadSprite("DaewonamiteThumb.png"),
					AfterSpawn = (Instance) => 
					{
						Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Daewonamite.png"); 
						Instance.FixColliders();
						
						//MadeByBarBeQ
						//Commission #1
					}
				}
			);
			ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("9mm Pistol"),
                    NameOverride = "Daewlock",
                    DescriptionOverride = "Daewo is killer.",
                    CategoryOverride = ModAPI.FindCategory("Daewo"),
                    ThumbnailOverride = ModAPI.LoadSprite("ThumbGlock.png"),
                    AfterSpawn = (Instance) =>
                    {
                        ModAPI.KeepExtraObjects();
												
                        var Slide = Instance.transform.Find("Slide");
                        Slide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Slide.png");
													
						Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Daewlock.png");				

						//MadeByBarBeQ
						//Commission #1
					}
                }
            );
			ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Daewohat",
                    DescriptionOverride = "Hat 4 fun.",
                    CategoryOverride = ModAPI.FindCategory("Daewo"),
                    ThumbnailOverride = ModAPI.LoadSprite("dsfd.png"),
                    AfterSpawn = (Instance) =>
                    {                       				
						Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Daewohat.png");	
						Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Wood");		
						Instance.FixColliders();						
						
						ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 15f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 1;
						
						//MadeByBarBeQ
						//Commission #1
					}
                }
            );
			ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Ceiling Turret"),
                    NameOverride = "DaewOS",
                    DescriptionOverride = "010010100111>@#!?",
                    CategoryOverride = ModAPI.FindCategory("Daewo"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumb7.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("CeilingTurret1.png");			
												
                        var Slide = Instance.transform.Find("Barrel");
                        Slide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("CeilingTurret2.png");
						
						var Light1 = Instance.transform.Find("light");
                        Light1.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
						
						var Light2 = Instance.transform.Find("light 2");
                        Light1.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
												
						Instance.FixColliders();	

						//MadeByBarBeQ
						//Commission #1
					}
                }
            );
		}
	}
}